//
//  FilePlayerController.h
//  PlayFileCocoa
//
//  Copyright 2011 JG Electronics. All rights reserved.
//	Remarks, reports to: www.jgelectronics.nl.
//
//	Derived from Apple's example program PlayFile and chapter 7 of the book Core Audio, authors Kevin Avila and Chris Adamson.
//	The application icon is from Vincent Garnier http://benjigarner.deviantart.com/art/Fruity-Apples-80805804
//
//	OSX10.6 and XCODE 4.0.1
//
/*
 Disclaimer: IMPORTANT: 
 This JG Electronics software is supplied to you by JG Electronics as FREE AND OPEN SOURCE SOFTWARE. 
 
 The JG Electronics Software is provided by JG Electronics on an "AS IS" basis.
 JG ELECTRONICS MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS
 FOR A PARTICULAR PURPOSE, REGARDING THE JG ELECTRONICS SOFTWARE OR ITS USE AND
 OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
 
 IN NO EVENT SHALL JG ELECTRONICS BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION,
 MODIFICATION AND/OR DISTRIBUTION OF THE JG ELECTRONICS SOFTWARE, HOWEVER CAUSED
 AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE),
 STRICT LIABILITY OR OTHERWISE, EVEN IF JG ELECTRONICS HAS BEEN ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
 */

#import <Foundation/Foundation.h>
#import "FilePlayerModel.h"


@interface FilePlayerController : NSObject {
@private
//	windows, views, buttons
	FilePlayerModel *			fpFilePlayerPtr;
	IBOutlet NSWindow *			fpWindow;
	IBOutlet NSTextField *		fpTimeLeft;
	IBOutlet NSTextField *		fpTimeGone;
	IBOutlet NSButton *			fpSpeakerBevelButton;
	IBOutlet NSSlider *			fpFileProgressInd;
	BOOL						fpIsRunning;
	BOOL						fpNewFile;
	BOOL						fpFileUrl;
	NSURL *						url;
	float						amplitudeFlt;
//	
	NSNumber *					fpMaxTime;
	double						fpFileRunTime;
	double						fpRunTimeLeft;
	double						fpRunTimeGone;
}

//	archive strings
	@property (copy) NSURL *			url;
	@property (copy) NSNumber *			fpMaxTime;
	@property(readwrite, assign) float	amplitudeFlt;
	@property(readwrite, assign) double	fpRunTimeLeft, fpRunTimeGone;

- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context;
//	notifications
- (void)fpTimeMaxNotification:(NSNotification *)notification;
- (void)fpTimerNotification:(NSNotification *)notification;
- (void)fpPlayBackEndNotification:(NSNotification *)notification;
//
- (IBAction)fpReadButtons:(id)sender;
- (IBAction)fpOpenSoundFile:(id)sender;
- (void)fpSetMuteButtonImage;

@end
